import * as types from "../constants/actionTypes";

import axios from "axios";
import AxiosInstance from "axios";

const getCategory = payload => ({
	type: types.GET_CATEGORY,
	payload
});

const getCategorySuccess = payload => ({
	type: types.GET_CATEGORY_SUCCESS,
	payload
});

const getCategoryFail = payload => ({
	type: types.GET_CATEGORY_FAIL,
	payload
});

export const getCategoryRequest = ({ page = 1, size = 5 }) => async dispatch => {
	dispatch(getCategory());
	// const token = localStorage.getItem("token");
	try {
		// const { data } = await axios({
		// 	method: "GET",
		// 	url: "test-app/category",
		// 	headers: {
		// 		Authorization: `Bearer ${token}`
		// 	},
		// 	params: {
		// 		page,
		// 		size
		// 	}
		// });
		const data = await AxiosInstance({
			method: "POST",
			data: {},
			url: "test-app/category"
		});

		console.log(data);
		dispatch(getCategorySuccess(data));
	} catch (err) {
		dispatch(getCategoryFail(err));
	}
};

const createCategory = payload => ({
	type: types.CRETE_CATEGORY,
	payload
});

const createCategorySuccess = payload => ({
	type: types.CRETE_CATEGORY_SUCCESS,
	payload
});

const createCategoryFail = payload => ({
	type: types.CRETE_CATEGORY_FAIL,
	payload
});

export const create = payload => async dispatch => {
	dispatch(createCategory());
	try {
		const token = localStorage.getItem("token");
		const { data } = await axios({
			method: "POST",
			url: "https://test-app-a-level.herokuapp.com/api/test-app/category",
			headers: {
				Authorization: `Bearer ${token}`
			},
			data: payload
		});

		dispatch(createCategorySuccess(data));
	} catch (e) {
		dispatch(createCategoryFail(e.response));
	}
};

const deleteCategory = payload => ({
	type: types.DELETE_CATEGORY,
	payload
});

const deleteCategorySuccess = payload => ({
	type: types.DELETE_CATEGORY_SUCCESS,
	payload
});

const deleteCategoryFail = payload => ({
	type: types.DELETE_CATEGORY_FAIL,
	payload
});

export const deleteC = payload => async dispatch => {
	dispatch(deleteCategory());
	try {
		const token = localStorage.getItem("token");
		await axios({
			method: "DELETE",
			url: `https://test-app-a-level.herokuapp.com/api/test-app/category/${payload}`,
			headers: {
				Authorization: `Bearer ${token}`
			}
		});

		dispatch(deleteCategorySuccess(payload));
	} catch (e) {
		dispatch(deleteCategoryFail(e.response));
	}
};

const updateCategory = payload => ({
	type: types.UPDATE_CATEGORY,
	payload
});

const updateCategorySuccess = payload => ({
	type: types.UPDATE_CATEGORY_SUCCESS,
	payload
});

const updateCategoryFail = payload => ({
	type: types.UPDATE_CATEGORY_FAIL,
	payload
});

export const update = payload => async dispatch => {
	const { id, values } = payload;
	dispatch(updateCategory());
	try {
		const token = localStorage.getItem("token");
		const { data } = await axios({
			method: "PUT",
			url: `https://test-app-a-level.herokuapp.com/api/test-app/category/${id}`,
			headers: {
				Authorization: `Bearer ${token}`
			},
			data: values
		});

		dispatch(updateCategorySuccess(data));
	} catch (e) {
		dispatch(updateCategoryFail(e.response));
	}
};
