import React from "react";
import { reduxForm, Field, FieldArray } from "redux-form";

import { renderField, renderCheckbox, renderSelect, renderArr } from "../common";

const OPTIONS = [
	{ id: 1, value: "has", name: "Есть что-то" },
	{ id: 2, value: "not", name: "Будет голодным" },
	{ id: 3, value: "some", name: "Я подумаю" }
];

const form = props => {
	const { handleSubmit } = props;
	const submit = values => console.log("values", values);

	return (
		<form onSubmit={handleSubmit(submit)}>
			<Field name="name" lable="Name" component={renderField} />
			<Field name="class" type="number" lable="Class" component={renderField} />
			<Field name="school" lable="School" component={renderField} />
			<Field name="morningTime" lable="Time2" component={renderCheckbox} />
			<Field name="breackfast" lable="BreackFast" component={renderSelect}>
				{OPTIONS.map(el => (
					<option key={el.id} value={el.value}>
						{el.name}
					</option>
				))}
			</Field>

			<FieldArray name="backPack" component={renderArr} />

			<button>Отправить в школу!</button>
		</form>
	);
};

export default reduxForm({ form: "school", enableReinitialize: true })(form);
