import React, { Component } from "react";
import { Field, reduxForm } from "redux-form";

import { signInValidation } from "../../utils/validate";
import { renderField } from "../common";

class SignIn extends Component {
	submit = values => {
		const { auth } = this.props;

		auth(values);
	};

	googleAuth = () => {
		const ga = window.gapi.auth2.init({
			client_id: "665483657556-2qrnlhpqcp3ap5j5kq4u1eas2a0o3h23.apps.googleusercontent.com"
		});

		ga.signIn().then(info => {
			const { Zi } = info;
			fetch("http://localhost:5000/api/auth/google", {
				method: "POST",
				headers: {
					"Content-Type": "application/json"
				},
				body: JSON.stringify({ access_token: Zi.access_token })
			})
				.then(res => res.json())
				.then(res => console.log("res", res))
				.catch(err => console.log(err.response));
		});
	};

	render() {
		const { handleSubmit, submitting, pristine } = this.props;
		// console.log("da", this.props);
		return (
			<form onSubmit={handleSubmit(this.submit)}>
				<Field name="email" type="email" label="Email" component={renderField} />
				<Field name="password" type="password" label="password" component={renderField} />

				<button disabled={pristine || submitting}>Sign In</button>
				<button type="button" onClick={this.googleAuth}>
					Google link
				</button>
			</form>
		);
	}
}

export default reduxForm({ form: "signIn", validate: signInValidation })(SignIn);
