import React, { Component } from "react";
import { connect } from "react-redux";
import { bindActionCreators } from "redux";
import { Redirect } from "react-router-dom";

import * as actions from "../actions/auth";
import SignIn from "../components/signIn";
import SignUp from "../components/signUp";

class Auth extends Component {
	state = { switchForm: false };

	componentDidMount() {
		this.loadJS("https://apis.google.com/js/platform.js?onload=init");
	}

	loadJS = src => {
		const body = window.document.getElementsByTagName("body")[0];
		const ref = body.getElementsByTagName("script")[0];

		const script = window.document.createElement("script");
		script.src = src;
		script.async = true;
		script.defer = true;
		script.onload = () => {
			window.gapi.load("auth2", () => {
				console.log("success");
			});
		};
		ref.parentNode.insertBefore(script, ref);
	};

	switchForm = () => this.setState(prevState => ({ switchForm: !prevState.switchForm }));

	render() {
		const { switchForm } = this.state;
		const { auth, token } = this.props;
		// console.log("singInForm", singInForm);
		if (token) {
			return <Redirect to="/" />;
		}

		return (
			<div className="auth-box">
				<div className="auth-box__wrapper">
					{switchForm ? <SignUp /> : <SignIn auth={auth} token={token} />}

					<button onClick={this.switchForm}>Don't have account?</button>
				</div>
			</div>
		);
	}
}

const mapDispatchToProps = dispatch => bindActionCreators({ ...actions }, dispatch);

const mapStateToProps = state => ({
	token: state.auth.token
	// singInForm: state.form.signIn
});

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(Auth);
