import * as types from "../constants/actionTypes";

import initialState from "../store/initialState";

export default (state = initialState.category, { type, payload }) => {
	switch (type) {
		case types.GET_CATEGORY: {
			return { ...state, isFetching: true };
		}
		case types.GET_CATEGORY_SUCCESS: {
			const { count, category } = payload;
			return { ...state, data: category, totalCount: count, isFetching: false };
		}
		case types.GET_CATEGORY_FAIL: {
			return { ...state, isFetching: false };
		}

		case types.CRETE_CATEGORY: {
			return { ...state, isFetching: true };
		}
		case types.CRETE_CATEGORY_SUCCESS: {
			return { ...state, isFetching: false, data: state.data.concat(payload) };
		}
		case types.CRETE_CATEGORY_FAIL: {
			return { ...state, isFetching: false };
		}

		case types.DELETE_CATEGORY: {
			return { ...state, isFetching: true };
		}
		case types.DELETE_CATEGORY_SUCCESS: {
			const data = state.data.filter(el => el._id !== payload);

			return { ...state, isFetching: false, data };
		}
		case types.DELETE_CATEGORY_FAIL: {
			return { ...state, isFetching: false };
		}

		case types.UPDATE_CATEGORY: {
			return { ...state, isFetching: true };
		}
		case types.UPDATE_CATEGORY_SUCCESS: {
			const data = state.data.map(el => (el._id === payload._id ? payload : el));
			return { ...state, isFetching: false, data };
		}
		case types.UPDATE_CATEGORY_FAIL: {
			return { ...state, isFetching: false };
		}

		default:
			return state;
	}
};
