import * as types from "../constants/actionTypes";

import initialState from "../store/initialState";

export default (state = initialState.school, { type, payload }) => {
	switch (type) {
		case types.CHANGE_FIELD: {
			const { name, value } = payload;

			return {
				...state,
				newChildren: {
					...state.newChildren,
					[name]: value
				}
			};
		}
		case types.SUBMIT_USER: {
			const newChildren = {
				...state.newChildren,
				id: Math.random()
					.toString()
					.substr(2, 5),
				backPack: state.backPack
			};

			return { ...state, data: state.data.concat(newChildren) };
		}
		case types.ADD_FIELD_IN_ARR: {
			const item = {
				id: Math.random()
					.toString()
					.substr(2, 5),
				item: ""
			};

			return { ...state, backPack: state.backPack.concat(item) };
		}
		case types.CHANGE_FIELD_IN_ARR: {
			const { id, value } = payload;
			const backPack = state.backPack.map(el => (el.id === id ? { ...el, item: value } : el));
			return { ...state, backPack };
		}

		default:
			return state;
	}
};
