import React, { Component } from "react";
import { Switch, Route, withRouter } from "react-router-dom";
import { connect } from "react-redux";
import { bindActionCreators } from "redux";

import App from "./containers/App";
import Auth from "./containers/Auth";
import Category from "./containers/Category";
import Shkolota from "./containers/shkolota";

import Header from "./components/header";
import { setToken } from "./actions/auth";
import PrivateRoute from "./privateRouter";

class Router extends Component {
	componentDidMount() {
		const token = localStorage.getItem("token");

		if (token) {
			const { setToken } = this.props;
			return setToken(token);
		}
	}

	render() {
		return (
			<div className="container">
				<Header />
				<Switch>
					<PrivateRoute exact path="/" component={App} />
					<PrivateRoute exact path="/category/:id" component={Category} />
					<Route exact path="/auth" component={Auth} />
					<Route exact path="/school" component={Shkolota} />

					<Route render={() => <div>404 NOT FOUND</div>} />
				</Switch>
			</div>
		);
	}
}

const mapDispatchToProps = dispatch => bindActionCreators({ setToken }, dispatch);

export default withRouter(
	connect(
		null,
		mapDispatchToProps
	)(Router)
);
