export const signInValidation = ({ email, password }) => {
	const errors = {};
	if (!email) {
		errors.email = "Required";
	} else if (!/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i.test(email)) {
		errors.email = "Invalid email address";
	}

	if (!password) {
		errors.password = "Required";
	}

	return errors;
};

export const signUpValidation = ({ firstName, lastName, email, password, confirmPassword }) => {
	const errors = {};

	if (!firstName) {
		errors.firstName = "Required";
	}

	if (!lastName) {
		errors.lastName = "Required";
	}

	if (!email) {
		errors.email = "Required";
	} else if (!/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i.test(email)) {
		errors.email = "Invalid email address";
	}

	if (!password) {
		errors.password = "Required";
	}

	if (!confirmPassword) {
		errors.confirmPassword = "Required";
	} else if (password !== confirmPassword) {
		errors.password = "Not matched";
		errors.confirmPassword = "Not matched";
	}

	return errors;
};
